------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 2622 $ $Date: 2008-04-22 00:28:50 +0400 (Tue, 22 Apr 2008) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;

package body Qt_Ada.Internals.Objects.Object_Utilities is

   ----------------------------
   -- Corresponding_Q_Object --
   ----------------------------

   function Corresponding_Q_Object
    (Item : access Qt_Ada.Internals.Objects.QObject)
       return access Qt4.Objects.Q_Object'Class
   is
   begin
      if Item = null then
         return null;

      else
         return
           Qt4.Objects.Q_Object'Class
            (Qt_Ada.Internals.Object_Registry.To_Q_Object
              (Item).all)'Access;
      end if;
   end Corresponding_Q_Object;

   ---------------------------
   -- Corresponding_QObject --
   ---------------------------

   function Corresponding_QObject (Item : access constant Q_Object_Base'Class)
     return access Qt_Ada.Internals.Objects.QObject
   is
   begin
      if Item = null then
         return null;

      else
         return Item.QObject_View;
      end if;
   end Corresponding_QObject;

end Qt_Ada.Internals.Objects.Object_Utilities;
